from matplotlib import pyplot as plt

from skimage import data, io
from skimage.feature import corner_harris, corner_subpix, corner_peaks
from skimage.color import rgb2gray

image = io.imread('image.jpg') 
image = rgb2gray(image)
coords = corner_peaks(corner_harris(image), min_distance=5)
coords_subpix = corner_subpix(image, coords, window_size=13)

fig, ax = plt.subplots()
ax.imshow(image, interpolation='nearest', cmap=plt.cm.gray)
ax.plot(coords[:, 1], coords[:, 0], '.b', markersize=3)
ax.plot(coords_subpix[:, 1], coords_subpix[:, 0], '+r', markersize=15)
ax.axis((0, 350, 350, 0))
plt.show()
